from .models import * 
from rest_framework import serializers

class PatientVisitDrSerializer(serializers.ModelSerializer):
    visit_status_str = serializers.SerializerMethodField()
    pt_name = serializers.CharField(source="patient.fullname",default="",read_only=True)
    ms_name = serializers.CharField(source="medicalservice.name",default="",read_only=True)

    class Meta:
        model = PatientVisit
        #fields=('patient','visit_status_str', 'pt_name',"ms_name","rcptn_notes")
        fields=('id','patient_id','visit_status_str', 'pt_name',"ms_name")

    def get_visit_status_str(self, obj):
        return obj.get_visit_status_display()
    

class PatientVisitSerializer(serializers.ModelSerializer):
    visit_status_string = serializers.SerializerMethodField()
    patient_string = serializers.SerializerMethodField()
    medicalservice_string = serializers.SerializerMethodField()
    medicalservice_value = serializers.SerializerMethodField()
    entry_datetime = serializers.DateTimeField(format="%d/%m/%Y %H:%M")
    created_at = serializers.DateTimeField(format="%d-%m-%Y %H:%M")

    class Meta:
        model = PatientVisit
        fields="__all__"
        read_only_fields = ('visit_status_string', 'patient_string',"medicalservice_string","medicalservice_value")

    def get_visit_status_string(self, obj):
        return obj.get_visit_status_display()        
    def get_patient_string(self, obj):
        return obj.patient.fullname
    def get_medicalservice_string(self, obj):
        return obj.medicalservice.name
    def get_medicalservice_value(self, obj):
        return obj.medicalservice.price
    
